-- ship

local ship = {}

local sprite = love.graphics.newImage('spaceship.png')

ship.x = love.graphics.getWidth() / 2
ship.y = love.graphics.getHeight()
ship.dx = ship.x
ship.dy = ship.y
ship.shield = 3

local exhtexture = love.graphics.newImage('exhaust.png')
local exhaust = love.graphics.newParticleSystem(exhtexture, 500)
exhaust:setParticleLifetime(0.5, 2)
exhaust:setEmissionRate(250)
exhaust:setSizeVariation(1)
exhaust:setLinearAcceleration(-5, 30, 5, 35)
exhaust:setColors(1, 1, 0, 1, 1, 0, 0, 0) -- Fade to transparency.

local shake = love.graphics.newParticleSystem(sprite, 5)
shake:setParticleLifetime(0.5, 2) 
shake:setLinearAcceleration(-50, -50, 50, 50)
shake:setSizeVariation(1)
shake:setColors(1, 1, 1, 0.6, 1, 1, 0, 0)

function ship.update(dt)
  local vx = (ship.dx - ship.x) * 0.05
  local vy = (ship.dy - ship.y) * 0.05
  
  ship.x = ship.x + vx
  ship.y = ship.y + vy
  
  exhaust:update(dt)
  shake:update(dt)
end

function ship.draw()
  love.graphics.draw(exhaust, ship.x - 17, ship.y + 25)
  love.graphics.draw(exhaust, ship.x + 17, ship.y + 25)
  
  love.graphics.draw(sprite, ship.x, ship.y, 0, 1, 1, sprite:getWidth() / 2, sprite:getHeight() / 2 )
  love.graphics.draw(shake)
end

function ship.moveTo(dx, dy)
  ship.dx = dx
  ship.dy = dy
end

function ship.shake()
  shake:setPosition(ship.x, ship.y)
  shake:emit(5)
end

return ship